#include "glbf.h"

#include <SDL.h>

void init_sdl_gl() {
    int w = 640;
    int h = 480;

    SDL_Init(SDL_INIT_VIDEO);

	SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
	/* SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16); */
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);

    SDL_SetVideoMode(w, h, 16, SDL_OPENGL);

	SDL_WM_SetCaption("glbf test", "test_glbf");

    glClearColor(0, 0, 0, 0);

    glViewport(0, 0, w, h);

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity( );
	glOrtho(0, 640, 0, 480, -1, 1);

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE);
}

int main(int argc, char* argv[]) {
    int done = 0;
    int pockemon = 0;
    int turn = 0;
    int first;
    GLBitmapFont font;
    int ret;

    if (argc == 2) {
        if (strcmp(argv[1], "-h") == 0) {
            printf("%s [-h] [-p]\n", argv[0]);
            printf("\t-h: help\n");
            printf("\t-p: pockemon\n");
        }
        else if (strcmp(argv[1], "-p") == 0) {
            pockemon = 1;
        }
    }

    init_sdl_gl();

    /* ret = glbfInit(&font, "font.bmp", 10, 16, 16); */
    ret = glbfInit(&font, "kochi.bmp", 12, 14, 21);

    if (ret != 0) {
        printf("cannot open font!\n");
        return 0;
    }

    first = SDL_GetTicks();

    while (!done) {
        SDL_Event e;
        while (SDL_PollEvent(&e)) {
            if (e.type == SDL_QUIT ||
                (e.type == SDL_KEYDOWN &&
                 e.key.keysym.sym == SDLK_ESCAPE))
            {
                done = 1;
            }
        }

        glClear(GL_COLOR_BUFFER_BIT);

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();

        glEnable(GL_TEXTURE_2D);

        if (pockemon) {
            int period = 200;
            int t = SDL_GetTicks();
            int c = (t-first) % period;
            if (c < period/3) {
                glColor3f(1, 1, 1);
            }
            else if (c < period*2/3) {
                glColor3f(1, 0, 0);
            }
            else {
                glColor3f(0, 0, 1);
            }
        }
        else {
            glColor3f(1, 1, 1);
        }

        glPushMatrix();
        glTranslatef(320-67, 380, 0);
        glScalef(1.5, 1.5, 1);
        glbfPrint(font, "POCKEMON!");
        glPopMatrix();

        glPushMatrix();
        glTranslatef(320-45, 340, 0);
        glScalef(1, 1, 1);
        glbfPrint(font, "POCKEMON!");
        glPopMatrix();

        glPushMatrix();
        glTranslatef(320-90, 40, 0);
        glScalef(2, 2, 1);
        glbfPrint(font, "POCKEMON!");
        glPopMatrix();

        glPushMatrix();
        glTranslatef(320-225, 240-40, 0);
        glScalef(5, 5, 1);
        glbfPrint(font, "POCKEMON!");
        glPopMatrix();

        SDL_GL_SwapBuffers();

        turn++;
    }

    glbfQuit(font);

    SDL_Quit();

    return 0;
}
